package cn.com.qmth.examcloud.core.oe.student.face.service.impl;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.commons.helpers.concurrency.simple.Worker;
import cn.com.qmth.examcloud.commons.helpers.concurrency.simple.WorkerController;
import cn.com.qmth.examcloud.core.oe.common.base.Constants;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamCaptureQueueEntity;
import cn.com.qmth.examcloud.core.oe.common.enums.ExamCaptureQueueStatus;
import cn.com.qmth.examcloud.core.oe.student.face.service.ExamCaptureService;
import cn.com.qmth.examcloud.web.support.SpringContextHolder;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * face++人脸比对工作线程
 * 
 * @author lideyin 20190620
 */
public class FacePPCompareWorker implements Worker {
	private static final Logger log = LoggerFactory.getLogger(FacePPCompareWorker.class);
	private final Log captureLog = LogFactory.getLog("PROCESS_EXAM_CAPTURE_TASK_LOGGER");
	@Override
	public void process(WorkerController controller, Object element) {
		ExamCaptureService examCaptureService = SpringContextHolder
				.getBean(ExamCaptureService.class);
		ExamCaptureQueueEntity examCaptureQueueEntity = (ExamCaptureQueueEntity) element;
		try {
			examCaptureService.disposeFaceCompare(examCaptureQueueEntity);
		} catch (StatusException e) {
			//异常处理
			examCaptureQueueEntity.setErrorMsg(e.getDesc());
			examCaptureService.disposeFaceCompareFaild(examCaptureQueueEntity);
			if ((e.getCode().equals(Constants.FACE_COMPARE_CONCURRENCY_LIMIT_EXCEEDED))) {
				// 如果超过并发次数，则添加异常次数
				controller.addConcurrencyWarn();
			}else {
				captureLog.error("[BAIDU_FACELIVENESS_WORKER.] 自定义异常 "+e.getDesc(),e);
			}
		} catch (Exception e) {
			//异常处理
			examCaptureQueueEntity.setErrorMsg(e.getMessage());
			examCaptureService.disposeFaceCompareFaild(examCaptureQueueEntity);
			log.error("300001", "处理图片发生异常", e);
			captureLog.error("[BAIDU_FACELIVENESS_WORKER.] 系统异常 "+e.getMessage(),e);
		}
	}
}
